# table.rb
# http://www14.cds.ne.jp/~not/tawagoto/200102b.html#11_t1

=begin
ǵAPsڂɁuTable:vƏƂāAꂼ̒l^u؂ŋLq܂B
"[", "]" ň͂vf <th> ɂ܂BƐۂ̂͏ɉE񂹁B

Table:
@  [hoge1] [hoge2] [hoge3]
[foo]   test1   test2   test3
[bar]   -10 20% \10,000
=end

class Filter
  def table(str, type)
    case type
    when :PRE
      if str.sub!(/\A(table:\s*\n)/i, '') then
        table = "<table border=\"1\">\n"
        str.each{ |line|
          table << "\t<tr>"
          line.chomp.split(/\t/).each{ |item|
            if /^\[(.+)\]/ =~ item then
              table << "<th>#$1</th>"
            elsif /^[+-\\]?[\d,\.]+%?/ =~ item
              table << "<td align=\"right\">#{item}</td>"
            else
              table << "<td>#{item}</td>"
            end
          }
          table << "</tr>\n"
        }
        table << "</table>\n\n"
        str.replace(table)
        return :THROUGH
      end
    end
  end
end
